stages:
  - publish
  - deploy
variables:
  TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
  TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA

publish-staging:
  image: docker:latest
  stage: publish
  services:
  - name: docker:dind
    alias: thedockerhost
  tags:
    - big-box-publish
  variables:
    # Tell docker CLI how to talk to Docker daemon; see
    # https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#use-docker-in-docker-executor
    DOCKER_HOST: tcp://thedockerhost:2375/
    # Use the overlayfs driver for improved performance:
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  only:
    - staging
  script:
    - cp $STAGING_ENV .env    
    - docker build -t $TAG_COMMIT -t $TAG_LATEST ./
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker push $TAG_COMMIT
    - docker push $TAG_LATEST

publish-prod:
  image: docker:latest
  stage: publish
  services:
  - name: docker:dind
    alias: thedockerhost
  tags:
    - big-box-publish
  variables:
    # Tell docker CLI how to talk to Docker daemon; see
    # https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#use-docker-in-docker-executor
    DOCKER_HOST: tcp://thedockerhost:2375/
    # Use the overlayfs driver for improved performance:
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  only:
    - prod
  script:
    - cp $PROD_ENV .env    
    - docker build -t $TAG_COMMIT -t $TAG_LATEST ./
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker push $TAG_COMMIT
    - docker push $TAG_LATEST

deploy-staging:
  image: alpine:latest
  stage: deploy
  tags:
    - deployment    
  script:
    - chmod og= $ID_RSA_STAGING
    - apk update && apk add openssh-client
    - ssh -i $ID_RSA_STAGING -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP_STAGING "docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY"
    - ssh -i $ID_RSA_STAGING -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP_STAGING "docker pull $TAG_COMMIT"
    - ssh -i $ID_RSA_STAGING -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP_STAGING "docker tag $TAG_COMMIT data-dapp-ingress"    
    - ssh -i $ID_RSA_STAGING -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP_STAGING "docker-compose -f /data-dapp/docker-compose.yml up -d"
  environment:
    name: production
    url: http://gitlab.com
  only:
    - staging

deploy-prod:
  image: alpine:latest
  stage: deploy
  tags:
    - deployment    
  script:
    - chmod og= $ID_RSA_PROD
    - apk update && apk add openssh-client
    - ssh -i $ID_RSA_PROD -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP_PROD "docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY"
    - ssh -i $ID_RSA_PROD -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP_PROD "docker pull $TAG_COMMIT"
    - ssh -i $ID_RSA_PROD -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP_PROD "docker tag $TAG_COMMIT analytics-ingress"    
    - ssh -i $ID_RSA_PROD -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP_PROD "docker-compose -f /analytics/docker-compose.yml up -d"
  environment:
    name: production
    url: http://gitlab.com
  only:
    - prod
